
#include "mcm2191.h"
#include <signal.h>
#include <sysreg.h>

#include "datasize.h"
#include "fir.h"

extern int hcoeff[];

void sportHandler( int intr );


//**************************************************************************
//
//  CLoFi ^NX̓o
//
//  CLoFi^EZ-KIT 2191pNX fwEzKit2191 hBfwEzKit2191
//  EZ-KIT pAD1815t[[NBhandleBufferőMobt@
//  s
//
//**************************************************************************

class CLoFi : public mcm::fwEzKit2191
{
private:
	CFIR * lFilter, * rFilter;
public:	
	CLoFi();
	~CLoFi();
	virtual void handleBuffer( struct mcm::sample * bufTx, 
								struct mcm::sample * bufRx );
};

//**************************************************************************
//
//  CLoFi::handleBuffer̒`
//
//  handleBuffero[֐DMA]I邽тɎMobt@ƑM
//  obt@p[^ɌĂ΂BMobt@ɂ͒ODMAŎM
//  f[^ĂBhandleBuffer߂ƂɑMobt@Ƀf[^
//  ĂƁADMA]őMB
//
//  yf[^̃XeIM̓{[JZ^[ɂꍇB
//  ̏ꍇAE`l̍ƂƃZ^[E{[JB
//  JIPo͂Ɏg
//
//**************************************************************************
CLoFi::CLoFi() : mcm::fwEzKit2191()
{
	lFilter = new CFIR( hcoeff, TAPS );
	rFilter = new CFIR( hcoeff, TAPS );
}

CLoFi::~CLoFi()
{
	delete lFilter;
	delete rFilter;	
}

void CLoFi::handleBuffer( 	struct mcm::sample * bufTx, 
							struct mcm::sample * bufRx )
{
#if 1
    // sample by sample process
	for ( int i=0; i< this->bufSize; i++ ){		// bufSize͑Mobt@̒
		bufTx[i].l = lFilter->filter( bufRx[i].l );
		bufTx[i].r = rFilter->filter( bufRx[i].r );	// LchRch̍Ƃ
	}
#endif

#if 0
    // blocked process (1)
	lFilter->block_filter( &bufRx[0].l, sizeof(mcm::sample), &bufTx[0].l, sizeof(mcm::sample), this->bufSize );
	rFilter->block_filter( &bufRx[0].r, sizeof(mcm::sample), &bufTx[0].r, sizeof(mcm::sample), this->bufSize );
#endif

#if 0
    // blocked process (2)
	lFilter->block_filter2( &bufRx[0].l, sizeof(mcm::sample), &bufTx[0].l, sizeof(mcm::sample), this->bufSize );
	rFilter->block_filter2( &bufRx[0].r, sizeof(mcm::sample), &bufTx[0].r, sizeof(mcm::sample), this->bufSize );
#endif

}
//**************************************************************************
//
//  CX^X̍쐬
//
//  t[[N̔hNXÃCX^Xϐ
//  pӂĂ
//
//**************************************************************************

CLoFi *LoFi;			// g[NX[EASỸIuWFNg

//**************************************************************************
//
//  C֐
//
//  C֐ł͎̂Ƃs
//
//  1. 荞݃nho^
//  2. t[[ÑCX^X
//  3. t[[N̎s
//  4. R[fbN̏Î҂
//  5. R[fbÑ~[g
//  6. [v
//
//  ȏ̏͂قƂǂ̃vOŋʂł
//
//**************************************************************************

int main (void)
{
		
	interrupt( SIG_INT5 ,&sportHandler);				// 荞݃nho^
    enable_interrupts();                 // O[o荞݃Cl[u
						
	LoFi = new CLoFi( );							// CX^X
	LoFi->run();											// AC97Jn

								// AC97R[fbN̏Î҂
	while ( LoFi->currentState() != mcm::STATE_RUNNING )
		asm( "nop;" );
								// o͂̃~[g
	LoFi->tAC97Write( ac97::HEAD_VOLUME, ac97::gain( false, 15, 15 )  ); 
	LoFi->tAC97Write( ac97::RECORD_GAIN, ac97::gain( false, 8, 8 ) );
	
								// C[`ł͂Ƃ͊荞ݑ҂
	while( 1 )
		asm( "nop;" );
}

//**************************************************************************
//
//  荞݃nh
//  PɃCX^Xɐn
//
//**************************************************************************
void sportHandler( int intr )
{
	LoFi->handleInterrupt();	
}



